<template>
  <v-container fluid>
    <v-row>
      <v-col>
        <ProjectDescription
          :name="selectedProject.name"
          :address="selectedProject.address"
          :category="selectedProject.category"
          :icon="selectedProject.icon"
          :color="selectedProject.color"
          :count="selectedProject.count"
          :subcategory="selectedProject.subcategory"
          :responsible="selectedProject.responsible"
          :description="selectedProject.description"
          :coords="selectedProject.coords"
          :type="selectedProject.type"
          :email="selectedProject.email"
          :end-date="selectedProject.endDate"
          :website="selectedProject.website"
          :phone="selectedProject.phone"
        />
      </v-col>
    </v-row>

    <v-row v-if="photos.length">
      <v-col>
        <h2 class="title font-weight-bold main-text-color-2 mb-2">Фотографии</h2>

        <Carousel
          v-if="show"
          :id="projId"
          :images="photos"
          :index="index"
          fullscreen
        >
          <v-btn
            id="close-carousel"
            @click="show = false"

            icon
            large
            color="white"
          >
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </Carousel>

        <v-row class="d-none d-sm-flex">
          <v-col
            v-for="(img, i) in photos"
            :key="i"
            class="d-flex child-flex"
            cols="12"
            sm="6"
            md="4"
            lg="3"
            @click="onClickPhoto(i)"
          >
            <PhotoThumbnail :id="projId" :i="i" :img="img.name"/>
          </v-col>
        </v-row>

        <v-row class="d-flex d-sm-none">
          <v-col>
            <Carousel :id="projId" :images="photos"/>
          </v-col>
        </v-row>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
  import ProjectDescription from '../components/ProjectDescription';
  import Carousel from '../components/Carousel';
  import PhotoThumbnail from '../components/PhotoThumbnail';
  import {mapState} from 'vuex';

  export default {
    name: 'Project',
    components: {
      PhotoThumbnail,
      Carousel,
      ProjectDescription,
    },
    computed: {
      ...mapState('projects', [
        'selectedProject',
        'photos',
      ]),
      ...mapState('categories', [
        'categoriesLoadStatus',
      ]),
      projId: function() {
        return +this.$route.params.id;
      },
    },
    created() {
      if (this.categoriesLoadStatus === 'success') {
        this.$store.dispatch('projects/getProjectInfo', this.$route.params.id);
      }
      this.$store.dispatch('projects/getPhotos', this.$route.params.id);
    },
    data: () => ({
      index: null,
      show: false,
    }),
    methods: {
      onClickPhoto(i) {
        this.show = true;
        this.index = i;
      },
    },
    watch: {
      categoriesLoadStatus(newValue) {
        if (newValue !== 'success' && Object.keys(this.selectedProject).length) return;
        this.$store.dispatch('projects/getProjectInfo', this.$route.params.id);
      },
    },
  };
</script>

<style scoped>

</style>
